%% T-61.2010 Datasta tietoon / T#3 / 2
% Jukka Parviainen, 21.11.2006

%clear;         % poista muistista muuttujat
%clc;           % puhdista komentoikkunan ruutu
%close all;     % sulje kaikki ikkunat

%clear ind_data;  % jos haluat muuttaa "arvontaa"

%% kNN-luokitin
kNN = 1;  % valitse joko 1, 3 tai 5. Aloitetaan 1:st.
disp('********************************************************');
disp(['kNN-luokitin: valitaan ' num2str(kNN) ' lhint naapuria']);

%% Opetus- ja testiaineisto
% Yleens kytettviss oleva "labeloitu" aineisto                              
% jaetaan kahteen osaan: opetus- ja testiaineistoon
% (training & test).
%
% Yleisesti luokitin opetetaan opetusdatalla, mink                      
% jlkeen testidatalla lasketaan luokittimen luokitteluvirhe.
% Tmn jlkeen luokitinta kytetn aivan uuteen
% dataan, josta luokkaa ei tunneta vaan luokitin antaa sen.                             
%
% Ladataan data ja luokkatieto

load dt_t3_m2.mat
disp('Ladattiin muuttujat "data" ja "dclass"');
disp('Jokaiseen 2D-datapisteeseen liitty luokkatieto +1/-1, esim.');
disp(data(:, [1 70 130]));
disp(dclass([1 70 130]));

%% Jaetaan data opetus- ja testijoukkoon
% Valitaan satunnaisesti puolet datasta opetukseen.
% 
% Luokkana joko -1 tai +1.

N = size(data, 2);
if (exist('ind_data') ~= 1)
    % luodaan vain kerran! 
    % Jos haluat arpoa uudet pisteet, sano tai lis rivi "clear ind_data"
    ind_data = randperm(N);
end;

train = data(:, ind_data(1 : N/2));
test  = data(:, ind_data(N/2 + 1 : end));
classtrain = dclass(ind_data(1 : N/2));
classtest  = dclass(ind_data(N/2 + 1 :end));
N_train_A = sum(classtrain == 1);
N_test_A = sum(classtest == 1);
disp(['Nyt opetusjoukossa ' num2str(N_train_A) ' "+1":st ja ' num2str(N/2-N_train_A) ' "-1":st']);
disp(['ja testijoukossa ' num2str(N_test_A) ' "+1":st ja ' num2str(N/2-N_test_A) ' "-1":st']);

%% Piirretn data
% Siniset rastit ovat opetusjoukon nytteit, joiden
% luokka on +1,  siniset pallot opetusjoukon nytteit,
% joilla luokka -1 ja mustat timantit testijoukon nytteit,
% joiden luokkatieto tunnetaan, mutta se hydynnetn
% vasta laskettaessa luokittimen tuottamaa virhett.

ind_A = find(classtrain > 0);
ind_B = find(classtrain < 0);

figure(20+kNN); clf;
plot(train(1,ind_A), train(2, ind_A), 'bx');
hold on;
plot(train(1,ind_B), train(2, ind_B), 'bo');
pl1 = plot(test(1,:), test(2,:), 'kd');
title('Opetusdata kahdessa luokassa ja testidata');
legend({'Luokka +1 (train)','Luokka -1 (train)','Luokiteltavat pisteet (test)'});
axis equal;
grid on;

%% Lasketaan etisyysmatriisi datapisteist
DistVect   = pdist([train test]');
DistMatrix = squareform(DistVect);
Dist       = DistMatrix(N/2 + 1: end, 1:N/2);
% Tss ensimmisess riviss on etisyydet
% ensimmisest testipisteest kaikkiin opetuspisteisiin.

%% Lasketaan k-NN
class_correct   = 0;
class_incorrect = 0;
class_A = [];
class_B = [];
ind_incorrect = [];
class_A_was_B = [];
class_B_was_A = [];
 
for m = 1 : N/2
    [mins, ind_mins] = sort(Dist(m, :));
    classified = sum(dclass(ind_data(ind_mins(1:kNN))));
    if (sign(dclass(ind_data(m + N/2))) == sign(classified))
        class_correct = class_correct + 1;
        if (classified > 0)
            class_A = [class_A m];
        else
            class_B = [class_B m];
        end         
    else
        class_incorrect = class_incorrect + 1;
        ind_incorrect = [ind_incorrect m];
        if (classified < 0)
            class_A_was_B = [class_A_was_B m];
        else
            class_B_was_A = [class_B_was_A m];
        end         
    end;
end;
error = 100 * class_incorrect / (N/2);
disp(['Luokittelun tulos ' num2str(kNN) '-NN:']);
disp(['  oikein:  ' num2str(class_correct)]);
disp(['  vrin:  ' num2str(class_incorrect)]);
disp(['Luokitteluvirhe: ' num2str(error) '%']);        

if (exist('pl1') == 1), delete(pl1); end;
plot(test(1,class_A), test(2, class_A), 'gx');
plot(test(1,class_B), test(2, class_B), 'go');
plot(test(1,class_A_was_B), test(2, class_A_was_B), 'rx');
plot(test(1,class_B_was_A), test(2, class_B_was_A), 'ro');

title([num2str(kNN) '-NN: Opetusdata kahdessa luokassa, oikein ja vrin luokitetut']);
legend({'Luokka +1 (train)','Luokka -1 (train)', ...
    ['Oikein +1 [' num2str(length(class_A)) ']'], ...
    ['Oikein -1 [' num2str(length(class_B)) ']'], ...
    ['Vrin +1 [' num2str(length(class_A_was_B)) ']'], ...
    ['Vrin -1 [' num2str(length(class_B_was_A)) ']']});
shg;

%% Vertailu, kommentit
% Luokitteluvirheet 1-NN, 3-NN, 5-NN?
%
% Mit hyv / huonoa? Eroja 1, 3, 5?

